/* 
 *	HT Editor
 *	htendian.cc
 *
 *	Copyright (C) 1999, 2000, 2001 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htendian.h"
#include "global.h"

/* create network-order integer from i */
bool netint(void *buf, int i, int size)
{
	byte *b=(byte*)buf;
	switch (size) {
		case 1:
				b[0]=i;
				break;
		case 2:
				    b[0]=i>>8;
				    b[1]=i;
				break;
		case 4:
				    b[0]=i>>24;
				    b[1]=i>>16;
				    b[2]=i>>8;
				    b[3]=i;
				break;
		default:
				return 0;
	   }
	   return 1;
}

/* create host-order integer from buf */
bool hostint(int *i, const void *buf, int size)
{
	byte *b=(byte*)buf;
	switch (size) {
		case 1:
			*i=b[0];
			break;
		case 2:
			*i=(b[0]<<8) | b[1];
			break;
		case 4:
			*i=(b[0]<<24) | (b[1]<<16) | (b[2]<<8) | b[3];
			break;
		default:
			return 0;
	}
	return 1;
}

